/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.utilities.FieldStats;

 import java.awt.CardLayout;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.lib.basic.utilities.FieldStats.FieldStatsShared.*;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class GUI extends javax.swing.JPanel
{

    private Parameters parameters;

    /**
     * Creates new form SliceUI
     */
    public GUI()
    {
        initComponents();
    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    void updateGUI(ParameterProxy p, boolean resetFully, boolean setRunButtonPending)
    {
        if (p.get(META_COMPONENT_NAMES).length > 0) {
            boolean maskOrTime = p.get(META_IS_HAS_MASK_OR_IS_TIME_DEPENDENT);
            if (p.get(META_IS_REGULAR_FIELD)) {
                regularFieldStatsPanel.setProperties(parameters, p.get(SELECTED_COMPONENT), p.get(LOG_SCALE), p.get(META_NAME), p.get(META_DIMS), p.get(META_EXTENDS), p.get(META_PHYS_EXTENDS), p.get(META_COMPONENT_NAMES), p.get(META_SCHEMA), p.get(META_HISTOGRAM), maskOrTime ? null : p.get(META_AVG_GRAD), maskOrTime ? null : p.get(META_STDDEV_GRAD), maskOrTime ? null : p.get(META_DERIV_HISTOGRAM), maskOrTime ? null : p.get(META_THR_HISTOGRAM));
                ((CardLayout) getLayout()).show(this, "regular");
            } else {
                irregularFieldStatsPanel.setProperties(parameters, p.get(SELECTED_COMPONENT), p.get(LOG_SCALE), p.get(META_NAME), p.get(META_NNODES), p.get(META_EXTENDS), p.get(META_PHYS_EXTENDS), p.get(META_COMPONENT_NAMES), p.get(META_SCHEMA), p.get(META_HISTOGRAM));
                ((CardLayout) getLayout()).show(this, "irregular");
            }
        } else {
            ((CardLayout) getLayout()).show(this, "empty");
        }
    }

    /**
     * This method is called from within the constructor to initialize the form. WARNING: Do NOT
     * modify this code. The content of this method is always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        regularFieldStatsPanel = new org.visnow.vn.lib.gui.RegularFieldStatsPanel();
        irregularFieldStatsPanel = new org.visnow.vn.lib.gui.IrregularFieldStatsPanel();
        emptyPanel = new javax.swing.JPanel();

        setLayout(new java.awt.CardLayout());
        add(regularFieldStatsPanel, "regular");
        add(irregularFieldStatsPanel, "irregular");
        add(emptyPanel, "empty");
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel emptyPanel;
    private org.visnow.vn.lib.gui.IrregularFieldStatsPanel irregularFieldStatsPanel;
    private org.visnow.vn.lib.gui.RegularFieldStatsPanel regularFieldStatsPanel;
    // End of variables declaration//GEN-END:variables
}
